#include <stdio.h>
#include <stdlib.h>


int end_of_file=0;

int read_file(char *buf, int size)
{
  int R;
  R= fread(buf, 1, size, stdin);
#if 0
  if (R>0) {
     fprintf(stderr,"READ:\n-----\n");
     fwrite(buf, 1, R, stderr);
     fprintf(stderr,"\n-----\n"); 
  }
#endif
  if (R<=0) end_of_file= 1;
  else return R;
  return 0;
}

int comment(char *obuf, int osize)
{
   int isize= osize-1;
   char *ibuf;
   int ilen,olen;
   int i;
   static void* state= &&initial, *qret;
   static int K= 0, q;
  
   ibuf= alloca(isize);
   olen= 0; i= -1;
   ilen= read_file(ibuf, isize);
next:
   i++;
   if (i==ilen) return olen;
   goto *state;

initial:
  if (ibuf[i]=='\'' || ibuf[i]=='\"')
    { obuf[olen++]= q= ibuf[i]; state= &&quote; qret= &&initial; }
  else if (ibuf[i]=='/') state= &&first; 
  else obuf[olen++]= ibuf[i];
  goto next;
first:
  if (ibuf[i]=='/') { state= &&line_comment; goto next; }
  if (ibuf[i]=='*') { state= &&block_comment; goto next; }
  obuf[olen++]= '/';
  state= &&initial;
  goto initial;

line_comment:
  if (ibuf[i]=='\n') { obuf[olen++]= ' '; state= &&initial; }
  goto next;
block_comment:
  if (ibuf[i]=='*') state= &&maybe_end; 
  goto next;
maybe_end:
  if (ibuf[i]=='/') { state= &&initial; obuf[olen++]= ' '; goto next; }
  obuf[olen++]= '*';
  state= &&block_comment;
  goto block_comment;
quote:
   // printf("QUOTE (Q=[%d] %c) (%d) %c\n", q,q, ibuf[i], ibuf[i]);
   if (ibuf[i]==q) { if (!K) obuf[olen++]= q; state= qret; goto next; }
   if (ibuf[i]=='\\')
     { if (!K) obuf[olen++]= ibuf[i]; state= &&escape; goto next; }
   if (!K) obuf[olen++]= ibuf[i];
   goto next;

escape:
   // printf("ESCAPE (%d) %c\n", ibuf[i], ibuf[i]);
   if (!K) obuf[olen++]= ibuf[i];
   state= &&quote;
   goto next;
  return 0;
}

int line_cont(char *obuf, int osize)
{
   int isize= osize-1;
   char *ibuf;
   int ilen,olen;
   int i;
   static void* state= &&initial, *qret;
   static int K= 0, q;
  
   ibuf= alloca(isize);
   olen= 0; i= -1;
   ilen= comment(ibuf, isize);
next:
   i++;
   if (i==ilen) return olen;
   goto *state;

initial:
  if (ibuf[i]=='\'' || ibuf[i]=='\"')
    { obuf[olen++]= q= ibuf[i]; state= &&quote; qret= &&initial; }
  else if (ibuf[i]=='\\') state= &&skip; 
  else obuf[olen++]= ibuf[i];
  goto next;
skip:
  if (ibuf[i]=='\n') { state= &&initial; goto next; }
  if ((ibuf[i]>0 && ibuf[i]<=32) || ibuf[i]==127)
    { state= &&space; goto next; }
  obuf[olen++]= '\\';
  state= &&initial;
  goto initial;
space:
  if (ibuf[i]=='\n') { state= &&initial; goto next; }
  if ((ibuf[i]>0 && ibuf[i]<=32) || ibuf[i]==127) goto next;
  obuf[olen++]= '\\';
  obuf[olen++]= ' ';
  state= &&initial;
  goto initial;
quote:
   // printf("QUOTE (Q=[%d] %c) (%d) %c\n", q,q, ibuf[i], ibuf[i]);
   if (ibuf[i]==q) { if (!K) obuf[olen++]= q; state= qret; goto next; }
   if (ibuf[i]=='\\')
     { if (!K) obuf[olen++]= ibuf[i]; state= &&escape; goto next; }
   if (!K) obuf[olen++]= ibuf[i];
   goto next;

escape:
   // printf("ESCAPE (%d) %c\n", ibuf[i], ibuf[i]);
   if (!K) obuf[olen++]= ibuf[i];
   state= &&quote;
   goto next;
  return 0;
}

int directive(char *obuf, int osize)
{
   static int line_begin= 1;
   int isize= osize;
   char *ibuf;
   int ilen,olen;
   int i;
   static void* state= &&initial, *qret;
   static int K= 0, q;
  
   ibuf= alloca(isize);
   olen= 0; i= -1;
   ilen= line_cont(ibuf, isize);
next:
   i++;
   if (i==ilen) return olen;
   goto *state;

initial:
  switch(ibuf[i])
  {
  case '\n':
     line_begin=1; obuf[olen++]= '\n'; goto next;
  case '\'': case '\"':
     line_begin= 0; q= obuf[olen++]= ibuf[i];
     state= &&quote; qret= &&initial; goto next;
  case '#':
     if (line_begin) { K=1; state= &&direct; goto next; }
  default:
     if ((ibuf[i]>0 && ibuf[i]<=32) || ibuf[i]==127)
       { obuf[olen++]= ibuf[i]; goto next; }
     line_begin= 0;
     obuf[olen++]= ibuf[i];
     goto next;
  }
direct:
  // printf("DIRECTIVE: (%d) %c\n", ibuf[i],ibuf[i]);
  if (ibuf[i]=='\n') { line_begin=1; K=0; state= &&initial; }
  else if (ibuf[i]=='\'' || ibuf[i]=='\"')
     { q= ibuf[i]; qret= &&direct; state= &&quote; }
  goto next;

quote:
   // printf("QUOTE (Q=[%d] %c) (%d) %c\n", q,q, ibuf[i], ibuf[i]);
   if (ibuf[i]==q) { if (!K) obuf[olen++]= q; state= qret; goto next; }
   if (ibuf[i]=='\\')
     { if (!K) obuf[olen++]= ibuf[i]; state= &&escape; goto next; }
   if (!K) obuf[olen++]= ibuf[i];
   goto next;

escape:
   // printf("ESCAPE (%d) %c\n", ibuf[i], ibuf[i]);
   if (!K) obuf[olen++]= ibuf[i];
   state= &&quote;
   goto next;
  return 0;
}


int prototype(char *obuf, int osize)
{
   int isize= osize-1;
   char *ibuf;
   int ilen,olen;
   int i;
   static void* state= &&initial, *qret;
   static int K= 0, q;
  
   ibuf= alloca(isize);
   olen= 0; i= -1;
   ilen= directive(ibuf, isize);
next:
   i++;
   if (i==ilen) return olen;
   goto *state;
initial:
   switch(ibuf[i]) {
     case '{': K++; break;
     case '}':
       K--;
       // I won't give an error message. These will already be
       // caught by the compiler.
       if (K<0) K=0; 
       else if (K==0) { obuf[olen++]= ';'; obuf[olen++]= '\n'; }
       break;
     case '\'': 
     case '\"':
       state= &&quote; q= ibuf[i];
       if (!K) obuf[olen++]= ibuf[i];
       qret= &&initial;
       break; 
     default: if (!K) obuf[olen++]= ibuf[i]; break;
   }
   goto next;
quote:
   // printf("QUOTE (Q=[%d] %c) (%d) %c\n", q,q, ibuf[i], ibuf[i]);
   if (ibuf[i]==q) { if (!K) obuf[olen++]= q; state= qret; goto next; }
   if (ibuf[i]=='\\')
     { if (!K) obuf[olen++]= ibuf[i]; state= &&escape; goto next; }
   if (!K) obuf[olen++]= ibuf[i];
   goto next;

escape:
   // printf("ESCAPE (%d) %c\n", ibuf[i], ibuf[i]);
   if (!K) obuf[olen++]= ibuf[i];
   state= &&quote;
   goto next;
  // never reached, but it's OK.
  return 0;
}

int strip_spaces(char *obuf,int osize)
{
   int isize= osize-1;
   char *ibuf;
   int ilen,olen;
   int i;
   static void* state= &&initial, *qret;
   static int K= 0, q;
  
   ibuf= alloca(isize);
   olen= 0; i= -1;
   ilen= prototype(ibuf, isize);
next:
   i++;
   if (i==ilen) return olen;
   goto *state;

initial:
  if (ibuf[i]=='\'' || ibuf[i]=='\"')
    { obuf[olen++]= q= ibuf[i]; state= &&quote; qret= &&initial; goto next; }
  if (ibuf[i]=='\n') { state= &&newline; goto next; }
  obuf[olen++]= ibuf[i];
  goto next;
newline:
  if (ibuf[i]==';') { obuf[olen++]= ibuf[i]; state= &&initial; goto next; }
  if (ibuf[i]=='\n') { goto next; }
  obuf[olen++]= '\n';
  state= &&initial;
  goto initial;
quote:
   // printf("QUOTE (Q=[%d] %c) (%d) %c\n", q,q, ibuf[i], ibuf[i]);
   if (ibuf[i]==q) { if (!K) obuf[olen++]= q; state= qret; goto next; }
   if (ibuf[i]=='\\')
     { if (!K) obuf[olen++]= ibuf[i]; state= &&escape; goto next; }
   if (!K) obuf[olen++]= ibuf[i];
   goto next;

escape:
   // printf("ESCAPE (%d) %c\n", ibuf[i], ibuf[i]);
   if (!K) obuf[olen++]= ibuf[i];
   state= &&quote;
   goto next;
   return 0;
}

#define FUNC strip_spaces
#define BUFSIZE 100

int main()
{
   int L,i;
   char buf[BUFSIZE];
   while(!end_of_file) {
     L= FUNC(buf,BUFSIZE);
     if (L) fwrite(buf, 1, L, stdout);
   }
   printf("\n");
   return 0;  
}
